#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "rr_screen.h"
#include "rr_main.h"


void
on_mainwin_destroy                     (GtkObject       *object,
                                        gpointer         user_data)
{
  gtk_main_quit();
}


void
on_quit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_main_quit();
}


void
on_restart1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  RRMainGameReset();
}


void
on_stage_1_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  RRMainGameStage(0);
}


gboolean
on_screen_key_press_event              (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
  return(FALSE);
}


gboolean
on_screen_key_release_event            (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
  return(FALSE);
}

gboolean
on_mainwin_key_press_event             (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
  guint key;

  key = gdk_keyval_to_lower(event->keyval);
  RRMainKeyon(key);

  return FALSE;
}


gboolean
on_mainwin_key_release_event           (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
  guint key;

  key = gdk_keyval_to_lower(event->keyval);
  RRMainKeyoff(key);

  return FALSE;
}

gboolean
on_screen_expose_event                 (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
  return(RRScreenRedraw(widget, event, user_data));
}


void
on_stage_2_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  RRMainGameStage(1);
}


void
on_stage_3_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  RRMainGameStage(2);
}


void
on_stage_4_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  RRMainGameStage(3);
}


void
on_stage_5_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  RRMainGameStage(4);
}

