/*
 * Խػ! - ΥեGladeˤäƤޤ.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"

GtkWidget*
create_mainwin ()
{
  GtkWidget *mainwin;
  GtkWidget *vbox1;
  GtkWidget *menubar1;
  GtkWidget *file1;
  GtkWidget *file1_menu;
  GtkAccelGroup *file1_menu_accels;
  GtkWidget *quit1;
  GtkWidget *game1;
  GtkWidget *game1_menu;
  GtkAccelGroup *game1_menu_accels;
  GtkWidget *restart1;
  GtkWidget *stage1;
  GtkWidget *stage1_menu;
  GtkAccelGroup *stage1_menu_accels;
  GtkWidget *stage_1;
  GtkWidget *stage_2;
  GtkWidget *stage_3;
  GtkWidget *stage_4;
  GtkWidget *stage_5;
  GtkWidget *screen;
  GtkAccelGroup *accel_group;

  accel_group = gtk_accel_group_new ();

  mainwin = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name (mainwin, "mainwin");
  gtk_object_set_data (GTK_OBJECT (mainwin), "mainwin", mainwin);
  gtk_widget_set_events (mainwin, GDK_EXPOSURE_MASK | GDK_KEY_PRESS_MASK | GDK_KEY_RELEASE_MASK);
  gtk_window_set_title (GTK_WINDOW (mainwin), "Smart Pack");
  gtk_window_set_policy (GTK_WINDOW (mainwin), FALSE, FALSE, FALSE);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox1, "vbox1");
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (mainwin), vbox1);

  menubar1 = gtk_menu_bar_new ();
  gtk_widget_set_name (menubar1, "menubar1");
  gtk_widget_ref (menubar1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "menubar1", menubar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menubar1);
  gtk_box_pack_start (GTK_BOX (vbox1), menubar1, FALSE, FALSE, 0);
  gtk_menu_bar_set_shadow_type (GTK_MENU_BAR (menubar1), GTK_SHADOW_IN);

  file1 = gtk_menu_item_new_with_label ("File");
  gtk_widget_set_name (file1, "file1");
  gtk_widget_ref (file1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "file1", file1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (file1);
  gtk_container_add (GTK_CONTAINER (menubar1), file1);

  file1_menu = gtk_menu_new ();
  gtk_widget_set_name (file1_menu, "file1_menu");
  gtk_widget_ref (file1_menu);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "file1_menu", file1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (file1), file1_menu);
  file1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (file1_menu));

  quit1 = gtk_menu_item_new_with_label ("Quit");
  gtk_widget_set_name (quit1, "quit1");
  gtk_widget_ref (quit1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "quit1", quit1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (quit1);
  gtk_container_add (GTK_CONTAINER (file1_menu), quit1);
  gtk_widget_add_accelerator (quit1, "activate", accel_group,
                              GDK_Q, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  game1 = gtk_menu_item_new_with_label ("Game");
  gtk_widget_set_name (game1, "game1");
  gtk_widget_ref (game1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "game1", game1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (game1);
  gtk_container_add (GTK_CONTAINER (menubar1), game1);

  game1_menu = gtk_menu_new ();
  gtk_widget_set_name (game1_menu, "game1_menu");
  gtk_widget_ref (game1_menu);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "game1_menu", game1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (game1), game1_menu);
  game1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (game1_menu));

  restart1 = gtk_menu_item_new_with_label ("Restart");
  gtk_widget_set_name (restart1, "restart1");
  gtk_widget_ref (restart1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "restart1", restart1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (restart1);
  gtk_container_add (GTK_CONTAINER (game1_menu), restart1);
  gtk_widget_add_accelerator (restart1, "activate", accel_group,
                              GDK_R, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  stage1 = gtk_menu_item_new_with_label ("Stage");
  gtk_widget_set_name (stage1, "stage1");
  gtk_widget_ref (stage1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "stage1", stage1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (stage1);
  gtk_container_add (GTK_CONTAINER (menubar1), stage1);

  stage1_menu = gtk_menu_new ();
  gtk_widget_set_name (stage1_menu, "stage1_menu");
  gtk_widget_ref (stage1_menu);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "stage1_menu", stage1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (stage1), stage1_menu);
  stage1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (stage1_menu));

  stage_1 = gtk_menu_item_new_with_label ("Stage 1");
  gtk_widget_set_name (stage_1, "stage_1");
  gtk_widget_ref (stage_1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "stage_1", stage_1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (stage_1);
  gtk_container_add (GTK_CONTAINER (stage1_menu), stage_1);

  stage_2 = gtk_menu_item_new_with_label ("Stage 2");
  gtk_widget_set_name (stage_2, "stage_2");
  gtk_widget_ref (stage_2);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "stage_2", stage_2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (stage_2);
  gtk_container_add (GTK_CONTAINER (stage1_menu), stage_2);

  stage_3 = gtk_menu_item_new_with_label ("Stage 3");
  gtk_widget_set_name (stage_3, "stage_3");
  gtk_widget_ref (stage_3);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "stage_3", stage_3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (stage_3);
  gtk_container_add (GTK_CONTAINER (stage1_menu), stage_3);

  stage_4 = gtk_menu_item_new_with_label ("Stage 4");
  gtk_widget_set_name (stage_4, "stage_4");
  gtk_widget_ref (stage_4);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "stage_4", stage_4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (stage_4);
  gtk_container_add (GTK_CONTAINER (stage1_menu), stage_4);

  stage_5 = gtk_menu_item_new_with_label ("Stage 5");
  gtk_widget_set_name (stage_5, "stage_5");
  gtk_widget_ref (stage_5);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "stage_5", stage_5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (stage_5);
  gtk_container_add (GTK_CONTAINER (stage1_menu), stage_5);

  screen = gtk_drawing_area_new ();
  gtk_widget_set_name (screen, "screen");
  gtk_widget_ref (screen);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "screen", screen,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (screen);
  gtk_box_pack_start (GTK_BOX (vbox1), screen, TRUE, TRUE, 0);
  gtk_widget_set_usize (screen, 320, 240);
  gtk_widget_set_events (screen, GDK_EXPOSURE_MASK | GDK_KEY_PRESS_MASK | GDK_KEY_RELEASE_MASK);

  gtk_signal_connect (GTK_OBJECT (mainwin), "destroy",
                      GTK_SIGNAL_FUNC (on_mainwin_destroy),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mainwin), "key_press_event",
                      GTK_SIGNAL_FUNC (on_mainwin_key_press_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mainwin), "key_release_event",
                      GTK_SIGNAL_FUNC (on_mainwin_key_release_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (quit1), "activate",
                      GTK_SIGNAL_FUNC (on_quit1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (restart1), "activate",
                      GTK_SIGNAL_FUNC (on_restart1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (stage_1), "activate",
                      GTK_SIGNAL_FUNC (on_stage_1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (stage_2), "activate",
                      GTK_SIGNAL_FUNC (on_stage_2_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (stage_3), "activate",
                      GTK_SIGNAL_FUNC (on_stage_3_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (stage_4), "activate",
                      GTK_SIGNAL_FUNC (on_stage_4_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (stage_5), "activate",
                      GTK_SIGNAL_FUNC (on_stage_5_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (screen), "key_press_event",
                      GTK_SIGNAL_FUNC (on_screen_key_press_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (screen), "key_release_event",
                      GTK_SIGNAL_FUNC (on_screen_key_release_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (screen), "expose_event",
                      GTK_SIGNAL_FUNC (on_screen_expose_event),
                      NULL);

  gtk_window_add_accel_group (GTK_WINDOW (mainwin), accel_group);

  return mainwin;
}

