/* =====================================================================

   LiMo - Liblary
      Sync Main System.  - ᥤ롼

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Jan.24.2000  

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  RRMainInit       -- ᥤץʤ
  RRMainFree       -- λθ줳
  RRMainWindowSize -- ꡼󥵥μ
  RRMain           -- ֤˥뤵ᥤ

  RRMainKeyon      -- Key press event 
  RRMainKeyoff     -- Key release event 
  RRMainKeyget     -- ꥭƤ뤫ɤ֤

  RRMainGameReset   -- ƥץ쥤
  RRMainGameStage   -- ơʥС

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <math.h>
#include <gtk/gtk.h>
#include  "rr_main.h"
#include  "rr_screen.h"
#include  "rr_spriteman.h"
#include  "rr_puz01.h"


/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

#define  INTERVAL 20

/* --- ϴ¤ */
typedef struct _KeyMan KeyMan;
struct _KeyMan
{
  guint       keyval;         /* Ƥ륭 */
  guint       time;           /* Ƥλ */
};

/* --- ᥤ󥹥ƥåץ٥ */
enum {
  MS_INIT = 0,
  MS_STAGE_SET,
  MS_1P_ACT,
  MS_1P_THROW,
  MS_2P_ACT,
  MS_2P_THROW,
  MS_NEXT_TURN,
  MS_RESULT,
  MS_GAMEOVER
};

/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

/* --- ᥤ󥹥ƥå */
void  main_step(void);


/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

/* --- ǥץ쥤ݻ */
static gint  fw, fh;

/* --- ѿ */
static gint  int_handle;

/* --- ޡ */
static gint  timer;

/* --- ϴ */
static GList  *key_list;

/* --- ᥤ󥹥ƥå */
static gint  mainstep;

/* --- ץ쥤ơ */
static gint  play_stage;

/* --- 奿 */
static gint  play_turn;

/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  RRMainInit       -- ᥤץʤ

   return : void
   void

-------------------------------------------------------------- */
void RRMainInit(void)
{
  int_handle = 0;
  key_list = NULL;

  srand((unsigned int)time(NULL));

  RRScreenFontSetInit("-adobe-times-bold-r-normal-*-16-*-*-*-*-*-*-*,\
            -misc-fixed-medium-*-normal-*-16-*-*-*-*-*-jisx0208.1983-0");

  RRScreenClear(0x0000, 0x0000, 0x6000);

  /* -- ߳ */
  int_handle = gtk_timeout_add(1000/INTERVAL, (GtkFunction)RRMain, NULL);

  /* -- ν */
  Puz01_Init();

}


/* -------------------------------------------------------------
  RRMainFree       -- ᥤץཪλ

   return : void
   void

-------------------------------------------------------------- */
void RRMainFree(void)
{
  Puz01_Free();
}


/* -------------------------------------------------------------
  RRMainWindowSize   -- եå

   return : void
   void
-------------------------------------------------------------- */
void       RRMainWindowSize(gint w, gint h)
{
  fw = w;
  fh = h;
}


/* -------------------------------------------------------------
  RRMainGameReset   -- ƥץ쥤

   return : void
   void
-------------------------------------------------------------- */
void       RRMainGameReset(void)
{
  RRScreenClear(0x0000, 0x0000, 0x6000);
  Puz01_StageFree();
  mainstep = MS_STAGE_SET;
}


/* -------------------------------------------------------------
  RRMainGameStage   -- ơʥС

   return : void
   void
-------------------------------------------------------------- */
void       RRMainGameStage(gint n)
{
  play_stage = n;
  RRScreenClear(0x0000, 0x0000, 0x6000);
  Puz01_StageFree();
  mainstep = MS_STAGE_SET;
}


/* -------------------------------------------------------------
  RRMainKeyon      -- Key press event 

   return : void
   guint  keyval
-------------------------------------------------------------- */
void  RRMainKeyon(guint key)
{
  gint  i, n;
  gboolean flag;
  KeyMan *dat;
  GList   *p;

  /* --- ()ʣå */
  flag = FALSE;
  n = g_list_length(key_list);
  p = key_list;
  for(i=0; i<n; i++) {
    dat = p->data;
    if (dat->keyval == key) {
      flag = TRUE;
    }
    p = p->next;
  }
  /* --- ꥹȤϿ */
  if (flag == FALSE) {
    dat = g_malloc0(sizeof(KeyMan));
    dat->keyval = key;
    key_list = g_list_append(key_list, dat);
  }
}


/* -------------------------------------------------------------
  RRMainKeyoff     -- Key release event 

   return : void
   guint  keyval
-------------------------------------------------------------- */
void  RRMainKeyoff(guint key)
{
}


/* -------------------------------------------------------------
  RRMainKeyget     -- ꥭƤ뤫ɤ֤

   return : gboolean
   const guchar  keytop
-------------------------------------------------------------- */
gboolean RRMainKeyget(const gchar *keytop)
{
  guint  i, n, check;
  gboolean  r;
  KeyMan *dat = NULL;
  GList  *p;

  check = gdk_keyval_from_name(keytop);
  r = FALSE;
  n = g_list_length(key_list);
  p = key_list;
  for(i=0; i<n; i++) {
    dat = p->data;
    if (dat->keyval == check) {
      r = TRUE;
      break;
    }
    p = p->next;
  }
  return(r);
}


/* -------------------------------------------------------------
  RRMainKeyReset     -- ꥹȤΥꥢ

   return : gboolean
   const guchar  keytop
-------------------------------------------------------------- */
void RRMainKeyReset(void)
{
  gint  i, n;
  KeyMan *dat;
  GList   *p;

  /* ---  */
  n = g_list_length(key_list);
  p = key_list;
  for(i=0; i<n; i++) {
    dat = p->data;
    g_free(dat);
    p = p->next;
  }
  g_list_free(key_list);
  key_list = NULL;
}


/* -------------------------------------------------------------
  RRMain           -- ֤˥뤵ᥤ

   return : void
   void
-------------------------------------------------------------- */
gint RRMain(gpointer gdata)
{
  /* --- ʤȤʤޡ */
  timer++;

  /* --- Graphic Buffer Υå */
  RRScreenSwitch();

  /* --- ե졼 */
  main_step();

  /* --- ֥ */
  RRSpritemanAutoUpdate(0);

  RRMainKeyReset();

  return 1;
}


/* -------------------------------------------------------------
    --- Ƽ掠֥롼
-------------------------------------------------------------- */

/* --------------------------------------
   ᥤ󥹥ƥå
---------------------------------------- */
void  main_step(void)
{
  switch(mainstep) {
  case MS_INIT:
    play_stage = 0;
    mainstep = MS_STAGE_SET;
    break;

  case MS_STAGE_SET:
    Puz01_Stage(play_stage);
    RRSpritemanAllUpdate();
    play_turn = 5;
    mainstep = MS_1P_ACT;
    break;

  case MS_1P_ACT:
    if (Puz01_PlayerAct(0) == FALSE) {
      mainstep = MS_1P_THROW;
    }
    break;

  case MS_1P_THROW:
    if (Puz01_StoneMove() == FALSE) {
      mainstep = MS_2P_ACT;
    }
    break;

  case MS_2P_ACT:
    if (Puz01_PlayerAct(1) == FALSE) {
      mainstep = MS_2P_THROW;
    }
    break;

  case MS_2P_THROW:
    if (Puz01_StoneMove() == FALSE) {
      mainstep = MS_NEXT_TURN;
    }
    break;

  case MS_NEXT_TURN:
    play_turn--;
    if (play_turn == 0) {
      mainstep = MS_RESULT;
    }
    else {
      mainstep = MS_1P_ACT;
    }
    break;

  case MS_RESULT:
    /* --- ȯɽ */
    break;

  case MS_GAMEOVER:
    mainstep = MS_1P_ACT;
    break;
  }
}


/* -------------------------------------------------------------
    --- ˥塼μ
-------------------------------------------------------------- */

