/* =====================================================================

   LiMo - Liblary
      Puz01 Game.  - 

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Jan.24.2000  

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  Puz01_Init       -- ʤ
  Puz01_Free       -- Ȥޤ
  Puz01_Stage      -- ơ
  Puz01_StageFree  -- ơλ,ǡ
  Puz01_PlayerAct  -- ץ쥤䡼
  Puz01_StoneMove  -- ޤΰư

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>
#include  "rr_screen.h"
#include  "rr_spriteman.h"
#include  "rr_main.h"
#include  "rr_puz01.h"

/* --- 饯ǡ */
#include  "../picture/pix001.xpm"
#include  "../picture/pix004.xpm"
#include  "../picture/pix005.xpm"
#include  "../picture/pix006.xpm"

#include  "../picture/back001.xpm"


/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

/* --- ץ쥤䡼¤ */
typedef struct _Player Player;
struct _Player
{
  RRSObj     *playchar;       /* ץ쥤䡼饯 */
  RRSObj     *aimchar;        /* Ƚ७饯 */
  RRSObj     *scorechar[5];   /* ɽ֥ */
  guint       side;           /* ץ쥤䡼ֹ */
  guint       score;          /* ߤΥ */
  guint       pos_x;          /* Ū x ɸ */
  guint       ltimer;         /* Ƚѥޡ */
  guint       aim;            /* Ƚ */
  guint       power;          /* ѥڤӥѥΤ */
  gboolean    mode;           /* ѥ⡼ɤݤ */
};

/* --- ȡ¤ */
typedef struct _Stone Stone;
struct _Stone
{
  RRSObj     *stonechar;      /* ץ쥤䡼饯 */
  RRSObj     *scorechar[4];   /* ȡɽ */
  gint        side;           /* ץ쥤䡼(ʤ) */
  gint        size;           /* 礭(Ť) */
  gint        score;          /* 4Υȡͭ */
  gfloat      pos_x, pos_y;   /* ɸ */
  gfloat      pow;            /* ® */
  gfloat      vx, vy;         /* ư٥ */
  gfloat      add_vx, add_vy; /* ääư٥ */
};

/* --- ơɴ¤ */
typedef struct _Wall Wall;
struct _Wall
{
  gint         agl;           /* ɤ (0=, 1=) */
  gint        x, y;           /*  */
  gint        w, h;           /*  */
  RRSObj      *obj;           /* ɽ饯 */
};


/* -------------------------------------------------------------
 --- ơǡ
-------------------------------------------------------------- */
static Wall  stage_01[4] = {
  { 0, 160, 100, 0, 70, 0 },
  { 0, -1,  0, 160+24, 38, 0 },
  { 0, -1,  1, 160-24, 38, 0 },
  { 0, -1, -1, 160, 32, 0 }
};

static Wall  stage_02[3] = {
  { 0, 130, 70, 0, 80, 0 },
  { 0, 190, 70, 0, 80, 0 },
  { 0, -1, -1, 160, 32, 0 }
};

static Wall  stage_03[2] = {
  { 1, 80, 100, 160, 0, 0 },
  { 0, -1, -1, 160, 32, 0 }
};

static Wall  stage_04[7] = {
  { 1, 8, 110, 100, 0, 0 },
  { 1, 220-8, 110, 100, 0, 0 },
  { 0, -1,  0, 160+10, 32+10, 0 },
  { 0, -1,  0, 160-10, 32-10, 0 },
  { 0, -1,  1, 160-10, 32+10, 0 },
  { 0, -1,  1, 160+10, 32-10, 0 },
  { 0, -1, -1, 160, 32, 0 }
};

static Wall  stage_05[5] = {
  { 1, 80, 100, 160, 0, 0 },
  { 0, 160, 80, 0, 116, 0 },
  { 0, -1,  0, 160, 32+10, 0 },
  { 0, -1,  1, 160, 32-10, 0 },
  { 0, -1, -1, 160, 32, 0 }
};



static Wall *stage_list[] = {
  stage_01,
  stage_02,
  stage_03,
  stage_04,
  stage_05
};

/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

/* --- ץ쥤䡼 */
void  player_init(void);

/* --- ץ쥤䡼ɽ */
void  player_disp(gint);

/* --- ȡ */
void  stone_init(Stone *, gint, gint);

/* --- ȡͽ */
void  stone_shot(Stone *, gint);

/* --- ȡɽ */
void  stone_disp(Stone *);

/* --- ȡư(ܺ) */
void  stone_move(Stone *);

/* --- ȡɤξȽ */
void  wall_corrision(Stone *);

/* --- ȡƱΤξȽ */
void  stone_corrision(Stone *);

/* --- ȡ׻ */
void  stone_score(Stone *st);

/* --- ץ쥤䡼η׻ɽ */
void  score_disp(gint);

/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

/* --- 饯ǡ */
static GdkPixmap  *parts1, *parts2, *parts3, *parts4;
static GdkBitmap  *mask1, *mask2, *mask3, *mask4;
static GdkPixmap  *back1;
static RRSObj  *bg;

/* --- ץ쥤䡼 */
static Player  pl[2];

/* --- Υȡꥹ */
static GList  *stone_list;

/* --- Τٴꥹ */
static GList  *wall_list;

/* --- åȥݥȤκɸ */
static gfloat  target_x, target_y;


/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  Pux01_Init       -- ᥤץʤ

   return : void
   void

-------------------------------------------------------------- */
void Puz01_Init(void)
{
  /* -- եå pixmap  */
  parts1 = gdk_pixmap_create_from_xpm_d(RRScreenWindow()->window,
					&mask1,
					NULL,
					pix001_xpm);
  parts2 = gdk_pixmap_create_from_xpm_d(RRScreenWindow()->window,
					&mask2,
					NULL,
					pix006_xpm);
  parts3 = gdk_pixmap_create_from_xpm_d(RRScreenWindow()->window,
					&mask3,
					NULL,
					pix004_xpm);
  parts4 = gdk_pixmap_create_from_xpm_d(RRScreenWindow()->window,
					&mask4,
					NULL,
					pix005_xpm);
  back1 = gdk_pixmap_create_from_xpm_d(RRScreenWindow()->window,
				       NULL,
				       NULL,
				       back001_xpm);

  /* -- ֥ */
  RRSpritemanInit();
  RRSpritemanBGColor(0x0000, 0x0000, 0x6000);

  /* -- ץ쥤䡼 */
  player_init();

  /* -- ȡ */
  stone_list = NULL;

  /* - ط */
  bg = RRSpritemanBGNew();
  bg->obj.sw = TRUE;
  bg->obj.mask_offset = TRUE;
  bg->obj.objmap = back1;
  bg->obj.objmask = NULL;
  bg->obj.x = bg->obj.y = 0;
  bg->obj.w = 320;
  bg->obj.h = 240;
  bg->obj.ox = bg->obj.oy = 0;
  bg->obj.offset_x = bg->obj.offset_y = 0;
  bg->z = 2000;
}


/* -------------------------------------------------------------
  Puz01_Free       -- λ

   return : void
   void

-------------------------------------------------------------- */
void Puz01_Free(void)
{
  if (parts1 != NULL) gdk_pixmap_unref(parts1);
  if (parts2 != NULL) gdk_pixmap_unref(parts2);
  if (parts3 != NULL) gdk_pixmap_unref(parts3);
  if (parts4 != NULL) gdk_pixmap_unref(parts4);
  if (mask1 != NULL) gdk_bitmap_unref(mask1);
  if (mask2 != NULL) gdk_bitmap_unref(mask2);
  if (mask3 != NULL) gdk_bitmap_unref(mask3);
  if (mask4 != NULL) gdk_bitmap_unref(mask4);
  RRSpritemanFree();
}


/* -------------------------------------------------------------
  Puz01_Stage      -- ơ

   return : void
   void

-------------------------------------------------------------- */
void  Puz01_Stage(gint st)
{
  RRSprite  *obj;
  GList  *p;
  Stone  *o;
  Wall   *stage;
  gint  i, n;

  /* --- н */
  if (stone_list != NULL)  {
    n = g_list_length(stone_list);
    p = stone_list;
    for(i=0; i<n; i++) {
      o = p->data;
      RRSpritemanDestroy(o->stonechar);
      RRSpritemanDestroy(o->scorechar[0]);
      RRSpritemanDestroy(o->scorechar[1]);
      RRSpritemanDestroy(o->scorechar[2]);
      RRSpritemanDestroy(o->scorechar[3]);
      g_free(o);
      p = p->next;
    }
    g_list_free(stone_list);
    stone_list = NULL;
  }
  /* --- ɳ */
  if (wall_list != NULL)  {
    n = g_list_length(wall_list);
    p = wall_list;
    for(i=0; i<n; i++) {
      stage = p->data;
      RRSpritemanDestroy(stage->obj);
      stage->obj = NULL;
      p = p->next;
    }
    g_list_free(wall_list);
    wall_list = NULL;
  }

  /* ----- ơ */
  i = 0;
  stage = stage_list[st];
  while(i < 20) {
    /* --- ꥹȡ */
    if ((stage[i].x == -1) && (stage[i].y != -1)) {
      o = g_malloc(sizeof(Stone));
      if (o == NULL) {
	fprintf(stderr, "malloc error.\n");
	exit(-1);
      }
      stone_init(o, 0, (stage[i].y & 1));
      o->pos_x = (gfloat)stage[i].w;
      o->pos_y = (gfloat)stage[i].h;
      stone_list = g_list_append(stone_list, o);
      i++;
      continue;
    }
    /* --- åȰ */
    if ((stage[i].x == -1) && (stage[i].y == -1)) {
      target_x = (gfloat)stage[i].w;
      target_y = (gfloat)stage[i].h;
      break;
    }
    /* ---  */
    wall_list = g_list_append(wall_list, &stage[i]);
    stage[i].obj = RRSpritemanNew();
    stage[i].obj->sw = TRUE;
    stage[i].obj->z  = 250;
    obj = &(stage[i].obj->obj);
    if (stage[i].agl == 0) {
      obj->objmap = parts3;
      obj->objmask = mask3;
      obj->w = 8;
      obj->h = stage[i].h;
      obj->offset_x = 3;
      obj->offset_y = 0;
    }
    else {
      obj->objmap = parts4;
      obj->objmask = mask4;
      obj->w = stage[i].w;
      obj->h = 8;
      obj->offset_x = 0;
      obj->offset_y = 3;
    }
    obj->x = stage[i].x;
    obj->y = stage[i].y;
    obj->sw = TRUE;
    obj->mask_offset = TRUE;
    obj->ox = 0;
    obj->oy = 0;
    i++;
  }
  Puz01_StoneMove();
}


/* -------------------------------------------------------------
  Puz01_StageFree   -- ơλ,ǡ

   return : void
   void

-------------------------------------------------------------- */
void  Puz01_StageFree(void)
{
  GList  *p;
  Stone  *o;
  Wall   *w;
  gint  i, n;

  if (stone_list != NULL) {
    n = g_list_length(stone_list);
    p = stone_list;
    for(i=0; i<n; i++) {
      o = p->data;
      RRSpritemanDestroy(o->stonechar);
      RRSpritemanDestroy(o->scorechar[0]);
      RRSpritemanDestroy(o->scorechar[1]);
      RRSpritemanDestroy(o->scorechar[2]);
      RRSpritemanDestroy(o->scorechar[3]);
      g_free(o);
      p = p->next;
    }
    g_list_free(stone_list);
    stone_list = NULL;
  }
  if (wall_list != NULL) {
    n = g_list_length(wall_list);
    p = wall_list;
    for(i=0; i<n; i++) {
      w = p->data;
      RRSpritemanDestroy(w->obj);
      p = p->next;
    }
    g_list_free(wall_list);
    wall_list = NULL;
  }
}


/* -------------------------------------------------------------
  Puz01_PlayerAct  -- ץ쥤䡼

   return : gboolean (TRUE=äƤޤ, FALSE=)
   gint  side (0=1P, 1=2P)
-------------------------------------------------------------- */
gboolean  Puz01_PlayerAct(gint side)
{
  Stone  *st;
  gboolean  r;

  r = TRUE;

  if (pl[side].mode == FALSE) {
    /* ===== Ƚढ碌⡼ */
    pl[side].ltimer++;
    /* ---  */
    if (RRMainKeyget("i") == TRUE) {
      if (pl[side].pos_x > 0) {
	pl[side].pos_x--;
      }
    }
    if (RRMainKeyget("o") == TRUE) {
      if (pl[side].pos_x < 100) {
	pl[side].pos_x++;
      }
    }
    /* --- Ƚ */
    if (RRMainKeyget("a") == TRUE) {
      pl[side].mode = TRUE;
    }
  }
  else {
    /* ===== ѥ⡼ */
    pl[side].power += 5;
    if (pl[side].power > 100) {
      pl[side].power = 0;
    }
    /* --- 塼 */
    if (RRMainKeyget("a") == TRUE) {
      /* -- ȡο */
      st = g_malloc(sizeof(Stone));
      if (st == NULL) {
	fprintf(stderr, "malloc error.\n");
	exit(-1);
      }
      stone_init(st, 0, side);
      stone_list = g_list_append(stone_list, st);
      /* -- ȡΰư٥ȥ */
      stone_shot(st, side);
      /* -- Ȥޤ */
      player_disp(side);
      pl[side].power = 0;
      pl[side].mode = FALSE;
      r = FALSE;
    }
  }

  /* --- 饯ɽ */
  player_disp(side);

  return(r);
}


/* -------------------------------------------------------------
  Puz01_StoneMove  -- ޤΰư

   return : gboolean (ޤưƤ = TRUE)
   void

-------------------------------------------------------------- */
gboolean Puz01_StoneMove(void)
{
  GList     *lst;
  Stone     *s;
  gboolean  stat = FALSE;

  if (stone_list != NULL) {
    lst = stone_list;
    while(lst != NULL) {
      s = lst->data;
      stone_move(s);
      wall_corrision(s);
      stone_disp(s);
      if (s->pow > 0.0) {
	stat = TRUE;
      }
      lst = lst->next;
    }
  }
  score_disp(0);
  score_disp(1);

  return(stat);
}



/* -------------------------------------------------------------
    --- ؿ
-------------------------------------------------------------- */

/* --------------------------------------
   ץ쥤䡼
-------------------------------------- */
void  player_init(void)
{
  RRSprite  *o;
  gint  i, j;

  for(i=0; i<2; i++) {
    pl[i].side = i;
    pl[i].score = 0;
    pl[i].pos_x = 50;
    pl[i].ltimer = pl[i].aim = 0;
    pl[i].power = 0;
    pl[i].mode = FALSE;
    pl[i].playchar = RRSpritemanNew();
    pl[i].aimchar = RRSpritemanNew();
    pl[i].playchar->sw = TRUE;
    pl[i].playchar->z = 100;
    pl[i].aimchar->sw = TRUE;
    pl[i].aimchar->z = 100;
    o = &(pl[i].playchar->obj);
    o->sw = TRUE;
    o->mask_offset = TRUE;
    o->objmap = parts1;
    o->objmask = mask1;
    o->w = o->h = 16;
    o->ox = i * 16;
    o->oy = 0;
    o->offset_x = o->offset_y = 7;
    o = &(pl[i].aimchar->obj);
    o->sw = TRUE;
    o->mask_offset = TRUE;
    o->objmap = parts1;
    o->objmask = mask1;
    o->w = o->h = 16;
    o->ox = 32;
    o->oy = 0;
    o->offset_x = o->offset_y = 6;
    for(j=0; j<5; j++) {
      pl[i].scorechar[j] = RRSpritemanNew();
      pl[i].scorechar[j]->sw = TRUE;
      pl[i].scorechar[j]->z = 25;
      o = &(pl[i].scorechar[j]->obj);
      o->sw = TRUE;
      o->mask_offset = TRUE;
      o->objmap = parts2;
      o->objmask = mask2;
      o->w = o->h = 8;
      o->ox = 0;
      o->oy = 8;
      o->offset_x = o->offset_y = 0;
      o->x = 160 + (160 * i) - 32 - (j * 8); 
      o->y = 0;
    }
    player_disp(i);
    score_disp(i);
  }
}

/* --------------------------------------
   ץ쥤䡼ɽ
-------------------------------------- */
void  player_disp(gint n)
{
  RRSprite *o;
  guint  a, x, y;

  /* -- Τɽ */
  o = &(pl[n].playchar->obj);
  if (n == 0) {
    o->x = 30 + pl[n].pos_x;
  }
  else {
    o->x = 160 + 30 + pl[n].pos_x;
  }
  o->y = (240 - 24);
  /* -- Ƚɽ */
  a = (pl[n].ltimer * 4) % 240;
  if (a > 120) {
    a = 240 - a;
  }
  pl[n].aim = a;
  a += 30;
#ifdef M_PIl
  x = (gint)(cos(M_PIl * 2.0 * (double)a / 360.0) * 15.0);
  y = -(gint)(sin(M_PIl * 2.0 * (double)a / 360.0) * 15.0);
#else
  x = (gint)(cos(M_PI * 2.0 * (float)a / 360.0) * 15.0);
  y = -(gint)(sin(M_PI * 2.0 * (float)a / 360.0) * 15.0);
#endif
  x += o->x;
  y += o->y;
  o = &(pl[n].aimchar->obj);
  o->x = x;
  o->y = y;
  /* --- ѥɽ */
  if (pl[n].mode == TRUE) {
    RRScreenGCColor(0x0000, 0x0000, 0x0000);
    RRScreenRectangle(1, 30+(160*n), 230, 100, 8);
    RRScreenGCColor(0xf000, 0x6000, 0x6000);
    RRScreenRectangle(1, 30+(160*n), 230, pl[n].power, 8);
  }
}

/* --------------------------------------
   ȡ
-------------------------------------- */
void  stone_init(Stone *st, gint size, gint side)
{
  gint  i;
  RRSprite  *o;

  /* --- ֥ν */
  st->stonechar = RRSpritemanNew();
  st->scorechar[0] = RRSpritemanNew();
  st->scorechar[1] = RRSpritemanNew();
  st->scorechar[2] = RRSpritemanNew();
  st->scorechar[3] = RRSpritemanNew();
  st->vx = 0.0;
  st->vy = 0.0;
  st->pow = 0.0;
  st->add_vx = 0.0;
  st->add_vy = 0.0;
  st->size = size;
  st->side = side;
  st->score = 0;
  st->stonechar->sw = TRUE;
  st->stonechar->z = 50;
  st->scorechar[0]->sw = TRUE;
  st->scorechar[0]->z = 45;
  st->scorechar[1]->sw = TRUE;
  st->scorechar[1]->z = 45;
  st->scorechar[2]->sw = TRUE;
  st->scorechar[2]->z = 45;
  st->scorechar[3]->sw = TRUE;
  st->scorechar[3]->z = 45;
  o = &(st->stonechar->obj);
  o->sw = TRUE;
  o->mask_offset = TRUE;
  o->objmap = parts1;
  o->objmask = mask1;
  o->x = o->y = -16;
  o->w = o->h = 16;
  o->ox = (size * 16 * 2) + (side * 16) + 48;
  o->oy = 0;
  o->offset_x = o->offset_y = 7;
  for(i=0; i<4; i++) {
    o = &(st->scorechar[i]->obj);
    o->sw = TRUE;
    o->mask_offset = TRUE;
    o->objmap = parts2;
    o->objmask = mask2;
    o->x = o->y = -16;
    o->w = 4;
    o->h = 6;
    o->ox = 4 * 10;
    o->oy = 0;
    o->offset_x = o->offset_y = 0;
  }
}


/* --------------------------------------
   ȡ
-------------------------------------- */
void  stone_shot(Stone *st, gint side)
{
  guint  a;
  /* --- ͽХѥ᡼ */
  /* -- ͽг */
  a = (pl[side].ltimer * 4) % 240;
  if (a > 120) {
    a = 240 - a;
  }
  a += 30;
#ifdef M_PIl
  st->vx = (gfloat)(cos(M_PIl * 2.0 * (double)a / 360.0) * 15.0);
  st->vy = -(gfloat)(sin(M_PIl * 2.0 * (double)a / 360.0) * 15.0);
#else
  st->vx = (gfloat)(cos(M_PI * 2.0 * (float)a / 360.0));
  st->vy = -(gfloat)(sin(M_PI * 2.0 * (float)a / 360.0));
#endif
  /* -- ͽ® */
  st->pow = ((gfloat)(pl[side].power + 20)) / 15.0;
  if (st->pow == 0.0) st->pow = 0.1;
  /* -- ȡΰ */
  st->pos_x = (gfloat)pl[side].pos_x + 30 + (160 * side);
  st->pos_y = (gfloat)(240 - 24);
  st->pos_x += (st->vx * 16.0);
  st->pos_y += (st->vy * 16.0);
  /* -- ͥѥ᡼Ͻ */
  st->add_vx = 0; 
  st->add_vy = 0; 
}


/* --------------------------------------
   ȡɽ
-------------------------------------- */
void  stone_disp(Stone *st)
{
  gint  dx, dy;
  gint  score, num, base;
  gint  i;

  dx = (gint)st->pos_x;
  dy = (gint)st->pos_y;
  st->stonechar->obj.x = dx;
  st->stonechar->obj.y = dy;
  st->scorechar[0]->obj.x = dx;
  st->scorechar[0]->obj.y = dy-4;
  st->scorechar[1]->obj.x = dx + 4;
  st->scorechar[1]->obj.y = dy-4;
  st->scorechar[2]->obj.x = dx + 8;
  st->scorechar[2]->obj.y = dy-4;
  st->scorechar[3]->obj.x = dx + 12;
  st->scorechar[3]->obj.y = dy-4;
  /* --- ݥȥ󥸥ο */
  base = 1000;
  score = st->score;
  for(i=0; i<4; i++) {
    num = (gint)(score / base);
    st->scorechar[i]->obj.ox = 4 * num;
    score -= (num * base);
    base /= 10;
  }
}

/* --------------------------------------
   ȡư
-------------------------------------- */
void  stone_move(Stone *st)
{
  gfloat  mix_vx, mix_vy, d;

  /* --- αƶ */
  if ((st->add_vx != 0.0) || (st->add_vy != 0.0)) {
    mix_vx = st->vx * st->pow;
    mix_vy = st->vy * st->pow;
    mix_vx += st->add_vx;
    mix_vy += st->add_vy;
    d = (gfloat)sqrt((double)((mix_vx * mix_vx) + (mix_vy * mix_vy)));
    st->pow = d;
    st->vx = mix_vx / d;
    st->vy = mix_vy / d;
    st->add_vx = st->add_vy = 0.0;
  }
  /* --- ѥʬ */
  st->pos_x += (st->vx * st->pow);
  st->pos_y += (st->vy * st->pow);
  /* --- ȿͤȿ */
  if ((st->pos_x < 16.0) && (st->vx < 0.0)) {
    st->pos_x = 16.0 + (16.0 - st->pos_x);
    st->vx = -(st->vx);
  }
  if ((st->pos_x > 304.0) && (st->vx > 0.0)) {
    st->pos_x = 304.0 - (st->pos_x- 304.0);
    st->vx = -(st->vx);
  }
  if ((st->pos_y < 16.0) && (st->vy < 0.0)) {
    st->pos_y = 16.0 + (16.0 - st->pos_y);
    st->vy = -(st->vy);
  }
  if ((st->pos_y > 185.0) && (st->vy > 0.0)) {
    st->pos_y = 184.0 - (st->pos_y- 184.0);
    st->vy = -(st->vy);
  }
  /* --- Ƚ */
  stone_corrision(st);
  /* --- ໤ˤѥ */
  if (st->pow > 0.0) {
    st->pow -= 0.04;
    if (st->pow < 0.0) {
      st->pow = 0.0;
    }
  }
  /* --- åȤȤεΥʤ륹 */
  stone_score(st);
}


/* --------------------------------------
   ȡɤξȽ
-------------------------------------- */
void  wall_corrision(Stone *st)
{
  const gfloat  dist[3] = {8.0, 6.0, 4.0};
  GList  *lst;
  Wall   *chk;
  gint  i;
  gfloat  x1, y1, x2, y2, d, t;
  gfloat  dx, dy, hit, pv;
  gdouble r2;
  gboolean  side;

  /* --- ɤɤ줫ȾͤƤ뤫 */
  side = FALSE;
  lst = wall_list;
  while(lst != NULL) {
    chk = lst->data;
    x1 = (gfloat)chk->x;
    y1 = (gfloat)chk->y;
    x2 = (gfloat)(chk->x + chk->w);
    y2 = (gfloat)(chk->y + chk->h);
    /* -- ¦̤Ȥξͥå */
    if (chk->agl == 1) {
      /*  */
      if ((x1 < st->pos_x) && (x2 > st->pos_x)) {
	d = (gfloat)fabs((double)st->pos_y - y1);
	if (d < dist[st->size]) {
	  /*  */
	  t = dist[st->size] - d;
	  st->vy = -st->vy;
	  d = st->vy / (gfloat)fabs((double)st->vy);
	  st->pos_y += t * d;
	  side = TRUE;
	}
      }
    }
    else {
      /*  */
      if ((y1 < st->pos_y) && (y2 > st->pos_y)) {
	d = (gfloat)fabs((double)st->pos_x - x1);
	if (d < dist[st->size]) {
	  /*  */
	  t = dist[st->size] - d;
	  st->vx = -st->vx;
	  d = st->vx / (gfloat)fabs((double)st->vx);
	  st->pos_x += t * d;
	  side = TRUE;
	}
      }
    }
    if (side == FALSE) {
      /* -- ξüȤξͻ */
      for(i=0; i<2; i++) {
	if (i == 1) {
	  x1 = x2;
	  y1 = y2;
	}
	dx = x1 - st->pos_x;
	dy = y1 - st->pos_y;
	d = (gfloat)sqrt((double)((dx*dx) + (dy*dy)));
	hit = dist[st->size];
	if (hit > d) {
	  /* -- ͽ */
	  hit -= d;              /* ꤳΥ */
	  pv = hit / st->pow;    /* ʹԵΥȤꤳߤΨ
				    (֤ĤäλĤѥ) */
	  /* ꤳޤʤ٤ */
	  st->pos_x -= (st->vx * hit);
	  st->pos_y -= (st->vy * hit);
	  /* Ȥγٻ */
	  dx = x1 - st->pos_x;
	  dy = y1 - st->pos_y;
	  r2 = (gdouble)atan2((double)dx, (double)dy);
#ifdef M_PIl
	  if (r2 < 0) r2 += M_PIl;
	  r2 = fmod(r2, M_PIl);
	  /* ٤˱ȿͼ */
	  if (((r2 >= 0) && (r2 < 0.125*M_PIl)) ||
	      ((r2 >= 0.375*M_PIl) && (r2 < 0.625*M_PIl)) ||
	      ((r2 >= 0.875*M_PIl) && (r2 < 1.0*M_PIl))) {
	    st->vy = -st->vy;
	  }
	  else {
	    st->vx = -st->vx;
	  }
#else
	  if (r2 < 0) r2 += M_PI;
	  r2 = fmod(r2, M_PI);
	  /* ٤˱ȿͼ */
	  if (((r2 >= 0) && (r2 < 0.125*M_PI)) ||
	      ((r2 >= 0.375*M_PI) && (r2 < 0.625*M_PI)) ||
	      ((r2 >= 0.875*M_PI) && (r2 < 1.0*M_PI))) {
	    st->vy = -st->vy;
	  }
	  else {
	    st->vx = -st->vx;
	  }
#endif
	  /* ääƤʬ */
	  st->pos_x += (st->vx * pv * st->pow);
	  st->pos_y += (st->vy * pv * st->pow);
	}
      }
    }

    /* Ĥ */
    lst = lst->next;
  }
}


/* --------------------------------------
   ȡƱΤξȽʤ
-------------------------------------- */
void  stone_corrision(Stone *st)
{
  const gfloat    dist[3] = {8.0, 6.0, 4.0};
  GList  *lst;
  Stone  *chk;
  gfloat  dx, dy, d;
  gfloat  hit, pv, pow;
  gfloat  hitv_x, hitv_y;
  gdouble r1, r2, c;

  /* --- ɤ줫ȾͤƤ뤫 */
  pow = st->pow;
  lst = stone_list;
  while(lst != NULL) {
    chk = lst->data;
    /* -- Ȥ˥ҥåȤʤ */
    if (chk != st) {
      dx = chk->pos_x - st->pos_x;
      dy = chk->pos_y - st->pos_y;
      d = (gfloat)sqrt((double)((dx*dx) + (dy*dy)));
      hit = dist[st->size] + dist[chk->size];
      if (hit > d) {
	/* -- ͽ */
	hit -= d;              /* ꤳΥ */
	pv = hit / pow;    /* ʹԵΥȤꤳߤΨ
				  (֤ĤäλĤѥ) */
	/* ꤳޤʤ٤ */
	st->pos_x -= (st->vx * hit);
	st->pos_y -= (st->vy * hit);
	/* Ȥγٻ */
	dx = chk->pos_x - st->pos_x;
	dy = chk->pos_y - st->pos_y;
	d = (gfloat)sqrt((double)((dx*dx) + (dy*dy)));
	hitv_x = dx / d;
	hitv_y = dy / d;
	r1 = (gdouble)atan2((double)st->vx, (double)st->vy);
	r2 = (gdouble)atan2((double)hitv_x, (double)hitv_y);
	r2 -= r1;
	c = cos(r2);
	/* ؤαƶ */
	chk->add_vx += (hitv_x * c * pow);
	chk->add_vy += (hitv_y * c * pow);
	/* ʬؤαƶ */
	st->add_vx -= (hitv_x * c * pow);
	st->add_vy -= (hitv_y * c * pow);
	pow = (1 - c) * pow;
	/* ääƤʬ */
	st->pos_x += (st->vx * pv * pow);
	st->pos_y += (st->vy * pv * pow);
      }
    }
    lst = lst->next;
  }
}


/* -----------------------------------------
   ȡȥåȤεΥʤ
------------------------------------------ */
void  stone_score(Stone *st)
{
  gfloat  dx, dy;
  gint  s;

  dx = target_x - st->pos_x;
  dy = target_y - st->pos_y;
  s = (gint)1000000.0 / (dx*dx + dy*dy);
  if  (s > 9999)
    s = 9999; 
  if  (s < 0)
    s = 0;
  st->score = s;
}


/* -----------------------------------------
   ץ쥤䡼ɽ
------------------------------------------ */
void  score_disp(gint side)
{
  GList  *lst;
  Stone  *chk;
  gint  sc;
  gint  i, t;

  /* --- ߤΥ */
  sc = 0;
  lst = stone_list;
  while(lst != NULL) {
    chk = lst->data;
    if (chk->side == side) {
      sc += chk->score;
    }
    lst = lst->next;
  }
  /* --- ɽ */
  for(i=0; i<5; i++) {
    t = sc % 10;
    sc /= 10;
    pl[side].scorechar[i]->obj.ox = t * 8;
  }
}




