/* =====================================================================

   LiMo - Liblary
      Sprite Managemant.  - ץ饤Ȥδ

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Jan.19.2000  ߷ס
  Jan.20.2000  ̤·, åĥǥХå()
  Jan.21.2000  δ 1
  Feb.07.2000  BG˥Хȯ

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  RRSpritemanInit        -- ƥν
  RRSpritemanFree        -- ƥνλ
  RRSpritemanNew         -- ˥֥
  RRSpritemanDestroy     -- ֥˴
  RRSpritemanBGNew       -- BG֥(1ĤΤ)
  RRSpritemanBGDestroy   -- BG֥˴
  RRSpritemanBGColor     -- BG顼
  RRSpritemanAutoUpdate  -- åץǡȥå
  RRSpritemanAllUpdate   -- ꥯ
  RRSpritemanZSort       -- ꥹȤΥȤʤ
  RRSpritemanCheckUpdate -- 褷ʤФʤʤ֥check
  RRSpritemanUpdate      -- ֥β

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include  <string.h>

#include  "rr_screen.h"
#include  "rr_spriteman.h"

/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */


/* -------------------------------------------------------------
 --- Structure
-------------------------------------------------------------- */


/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

/* --- zͤˤɽ̥ȴؿ() */
gint  depth_sort_f(gconstpointer a, gconstpointer b);

/* --- zͤˤɽ̥ȴؿʹ߽) */
gint  depth_sort_b(gconstpointer a, gconstpointer b);

/* --- ŤʤäƤ뤫ɤȽ */
gboolean  check_over(RRSObj*, RRSObj*);

/* --- ŤʤäƤۤ褵뤿 */
void  redraw_over(void);

/* --- åץǡȴλ */
void      update_done(RRSObj*);


/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

/* --- ֥ȤΥꥹȴ */
static GList *sp_layer = NULL;

/* --- BGδ */
static RRSObj  *man_bg = NULL;
static gint     bg_r=0, bg_g=0, bg_b=0;

/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  RRSpritemanInit        -- ƥν

   return : 
-------------------------------------------------------------- */
void  RRSpritemanInit(void)
{
  sp_layer = NULL;
  man_bg = NULL;
  bg_r = bg_g = bg_b = 0;
}

/* -------------------------------------------------------------
  RRSpritemanFree        -- ƥνλ

   return : 
-------------------------------------------------------------- */
void  RRSpritemanFree(void)
{
  gint	i, n;

  /* -- ֥ȸġβ */
  n = g_list_length(sp_layer);
  for(i=0; i<n; i++) {
    g_free(g_list_nth_data(sp_layer, i));
  }
  /* -- ꥹȤβ */
  if (sp_layer != NULL) g_list_free(sp_layer);
  /* -- BGβ */
  if (man_bg != NULL) g_free(man_bg);
}

/* -------------------------------------------------------------
  RRSpritemanNew         -- ˥֥

   return : RRSObj* (֥ݥ)
-------------------------------------------------------------- */
RRSObj *RRSpritemanNew(void)
{
  RRSObj *ptr;

  ptr = g_malloc0(sizeof(RRSObj));
  if (ptr != NULL) {
    /* -- ꥹȤɲ */
    sp_layer = g_list_append(sp_layer, ptr);
  }
  return(ptr);
}

/* -------------------------------------------------------------
  RRSpritemanDestroy     -- ֥˴

   return : gint (0=done, other=ʥ֥Τޤ)
   RRSObj *obj
-------------------------------------------------------------- */
gint RRSpritemanDestroy(RRSObj *obj)
{
  gint  r = 0;

  if (g_list_find(sp_layer, obj) == NULL) {
    r = -1;
  }
  else {
    sp_layer = g_list_remove(sp_layer, obj);
    g_free(obj);
  }
  return(r);
}

/* -------------------------------------------------------------
  RRSpritemanBGNew       -- BG֥(1ĤΤ)

   return : RRSObj* (֥ݥ)
-------------------------------------------------------------- */
RRSObj *RRSpritemanBGNew(void)
{
  RRSObj *ptr;

  ptr = g_malloc0(sizeof(RRSObj));
  if (ptr != NULL) {
    if (man_bg != NULL) g_free(man_bg);
    man_bg = ptr;
  }
  return(ptr);
}

/* -------------------------------------------------------------
  RRSpritemanBGDestroy   -- BG֥˴

   return : gint (0=done, other=ʥ֥Τޤ)
   RRSObj *obj
-------------------------------------------------------------- */
gint RRSpritemanBGDestroy(RRSObj *obj)
{
  gint  r = 0;

  if (man_bg != obj) {
    r = -1;
  }
  else {
    man_bg = NULL;
    g_free(obj);
  }
  return(r);
}

/* -------------------------------------------------------------
  RRSpritemanBGColor     -- BG顼(ǥեȻñ)

   return : void
-------------------------------------------------------------- */
void RRSpritemanBGColor(gint r, gint g, gint b)
{
  bg_r = r;
  bg_g = g;
  bg_b = b;
}

/* -------------------------------------------------------------
  RRSpritemanZSort       -- ꥹȤΥȤʤ

   return : void
   gint  zsort (0=ء1=)
-------------------------------------------------------------- */
void RRSpritemanZSort(gint zsort)
{
  if (zsort == 0) {
    sp_layer = g_list_sort(sp_layer, (GCompareFunc)depth_sort_f);
    sp_layer = g_list_sort(sp_layer, (GCompareFunc)depth_sort_f);
  }
  else {
    sp_layer = g_list_sort(sp_layer, (GCompareFunc)depth_sort_b);
    sp_layer = g_list_sort(sp_layer, (GCompareFunc)depth_sort_b);
  }
}

/* -------------------------------------------------------------
  RRSpritemanAutoUpdate  -- åץǡȥå

   return :
   gint zsort (0=ء1=)
-------------------------------------------------------------- */
void RRSpritemanAutoUpdate(gint zsort)
{
  /* --- 3Ĥ̿˼¹Ԥ */
  RRSpritemanZSort(zsort);
  if (RRSpritemanCheckUpdate() == TRUE) {
    RRSpritemanUpdate();
  }
}

/* -------------------------------------------------------------
  RRSpritemanAllUpdate   -- ꥯ

   return :
   gint zsort (0=ء1=)
-------------------------------------------------------------- */
void RRSpritemanAllUpdate(void)
{
  /* --- update ե饰ΩƤ */
  GList *pt;
  RRSObj *o;
  gint  i, n;

  n = g_list_length(sp_layer);
  pt = sp_layer;
  for(i=0; i<n; i++) {
    o = (RRSObj *)pt->data;
    o->update = TRUE;
    pt = pt->next;
  }
  man_bg->update = TRUE;
}

/* -------------------------------------------------------------
  RRSpritemanCheckUpdate -- 褷ʤФʤʤ֥check

   return : gboolean (TRUE=ɬ, FALSE=ɬ)
-------------------------------------------------------------- */
gboolean RRSpritemanCheckUpdate(void)
{
  GList *pt;
  RRSObj *o;
  gint  i, n;
  gboolean  r = FALSE;

  /* --- ѹΤä֥Ϥ뤫 */
  n = g_list_length(sp_layer);
  pt = sp_layer;
  for(i=0; i<n; i++) {
    o = (RRSObj *)pt->data;
    if ((o->z != o->z_old) ||
	(o->obj.x != o->obj_old.x) ||
	(o->obj.y != o->obj_old.y) ||
	(o->obj.w != o->obj_old.w) ||
	(o->obj.h != o->obj_old.h) ||
	(o->obj.ox != o->obj_old.ox) ||
	(o->obj.oy != o->obj_old.oy) ||
	(o->obj.sw != o->obj_old.sw) ||
	(o->obj.mask_offset != o->obj_old.mask_offset) ||
	(o->obj.objmap != o->obj_old.objmap) ||
	(o->obj.objmask != o->obj_old.objmask)) {
      r = TRUE;
      o->update = TRUE;
    }
    pt = pt->next;
  }

  /* --- BG Ĵ٤ */
  if (man_bg != NULL) {
    o = man_bg;
    if ((o->z != o->z_old) ||
	(o->obj.x != o->obj_old.x) ||
	(o->obj.y != o->obj_old.y) ||
	(o->obj.w != o->obj_old.w) ||
	(o->obj.h != o->obj_old.h) ||
	(o->obj.ox != o->obj_old.ox) ||
	(o->obj.oy != o->obj_old.oy) ||
	(o->obj.sw != o->obj_old.sw) ||
	(o->obj.mask_offset != o->obj_old.mask_offset) ||
	(o->obj.objmap != o->obj_old.objmap) ||
	(o->obj.objmask != o->obj_old.objmask)) {
      r = TRUE;
      o->update = TRUE;
    }
  }

  return(r);
}

/* -------------------------------------------------------------
  RRSpritemanUpdate      -- ֥β

   return :
-------------------------------------------------------------- */
void RRSpritemanUpdate(void)
{
  GtkWidget *screen;
  GList  *pt;
  RRSObj  *o;
  RRSprite  pat;
  gint  i, n;
  gboolean  all_redraw;

  /* --- ֥ο */
  n = g_list_length(sp_layer);

  /* --- 񤭴ϰϤˤäƿȽ */
  all_redraw = FALSE;
  if (man_bg != NULL) {
    if (man_bg->update == TRUE) {
      RRSpritemanAllUpdate();
      all_redraw = TRUE;
    }
  }
  if (all_redraw == FALSE) {
    /* --- ֥ŤʤäƤ礽νŤʤäƤ륪֥
           ǽ񤭴ɬפΤǽŤʤΥå */
    redraw_over();
    /* --- 񤭴֥öä */
    if (man_bg != NULL) {
      g_memmove(&pat, &(man_bg->obj), (size_t)sizeof(RRSprite));
    }
    pt = sp_layer;
    for(i=0; i<n; i++) {
      o = (RRSObj *)(pt->data);
      if ((o->update == TRUE) && (o->obj_old.sw != FALSE)) {
	if ((man_bg == NULL) || (pat.sw == FALSE)) {
	  /* -- BG ƥ̵ */
	  RRScreenGCColor(bg_r, bg_g, bg_b);
	  RRScreenRectangle((gint)TRUE,
			    o->obj_old.x - o->obj_old.offset_x,
			    o->obj_old.y - o->obj_old.offset_y,
			    o->obj_old.w, o->obj_old.h);
	}
	else {
	  /* -- BG ƥ㤢 */
	  pat.x = o->obj_old.x - o->obj_old.offset_x;
	  pat.y = o->obj_old.y - o->obj_old.offset_y;
	  pat.w = o->obj_old.w;
	  pat.h = o->obj_old.h;
	  pat.ox = (o->obj_old.x - o->obj_old.offset_x) - 
	    man_bg->obj.x + man_bg->obj.offset_x;
	  pat.oy = (o->obj_old.y - o->obj_old.offset_y) -
	    man_bg->obj.y + man_bg->obj.offset_y;
	  RRScreenObjPut(&pat);
	}
      }
      pt = pt->next;
    }
  }

  /* --- BG񤭴ʤ */
  if (man_bg != NULL) {
    if (man_bg->update == TRUE) {
      if (man_bg->obj.objmask != NULL) {
	screen = RRScreenCanvas();
	RRScreenGCColor(bg_r, bg_g, bg_b);
	RRScreenRectangle((gint)TRUE,
			  man_bg->obj_old.x - man_bg->obj_old.offset_x,
			  man_bg->obj_old.y - man_bg->obj_old.offset_y,
			  man_bg->obj_old.w, man_bg->obj_old.h);
      }
      RRScreenObjPut(&(man_bg->obj));
      update_done(man_bg);
    }
  }

  /* --- 񤭴֥ɽ */
  pt = sp_layer;
  for(i=0; i<n; i++) {
    o = (RRSObj *)pt->data;
    if (o->update == TRUE) {
      RRScreenObjPut(&(o->obj));
      update_done(o);
    }
    pt = pt->next;
  }
}





/* -----------------------------------------------------------------------
 --- ؿ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  depth_sort_f      -- zͤˤɽ̥ȴؿ()
-------------------------------------------------------------- */
gint  depth_sort_f(gconstpointer a, gconstpointer b)
{
  RRSObj  *sa, *sb;

  sa = (RRSObj *)a;
  sb = (RRSObj *)b;
  return(sb->z - sa->z);
}

/* -------------------------------------------------------------
  depth_sort_b      -- zͤˤɽ̥ȴؿ(߽)
-------------------------------------------------------------- */
gint  depth_sort_b(gconstpointer a, gconstpointer b)
{
  RRSObj  *sa, *sb;

  sa = (RRSObj *)a;
  sb = (RRSObj *)b;
  return(sa->z - sb->z);
}

/* -------------------------------------------------------------
  check_over       -- ֥ŤʤäƤ뤫ݤ
-------------------------------------------------------------- */
gboolean  check_over(RRSObj *a, RRSObj *b)
{
  gboolean r = FALSE;
  gint pos[8];

  pos[0] = a->obj.x - a->obj.offset_x;
  pos[1] = a->obj.y - a->obj.offset_y;
  pos[2] = a->obj.x - a->obj.offset_x + a->obj.w;
  pos[3] = a->obj.y - a->obj.offset_y + a->obj.h;
  pos[4] = b->obj.x - b->obj.offset_x;
  pos[5] = b->obj.y - b->obj.offset_y;
  pos[6] = b->obj.x - b->obj.offset_x + b->obj.w;
  pos[7] = b->obj.y - b->obj.offset_y + b->obj.h;

  if (pos[0] < pos[4]) pos[0] = pos[4];
  if (pos[0] > pos[6]) pos[0] = pos[6];
  if (pos[2] < pos[4]) pos[2] = pos[4];
  if (pos[2] > pos[6]) pos[2] = pos[6];
  if (pos[1] < pos[5]) pos[1] = pos[5];
  if (pos[1] > pos[7]) pos[1] = pos[7];
  if (pos[3] < pos[5]) pos[3] = pos[5];
  if (pos[3] > pos[7]) pos[3] = pos[7];
  if ((pos[0] == pos[2]) || (pos[1] == pos[3])) {
    r = FALSE;
  }
  else {
    r = TRUE;
  }

  /* --- äѥȽŤʤ뤫⤷ʤΤǥå */
  if (r == FALSE) {
    pos[0] = a->obj_old.x - a->obj_old.offset_x;
    pos[1] = a->obj_old.y - a->obj_old.offset_y;
    pos[2] = a->obj_old.x - a->obj_old.offset_x + a->obj_old.w;
    pos[3] = a->obj_old.y - a->obj_old.offset_y + a->obj_old.h;

    if (pos[0] < pos[4]) pos[0] = pos[4];
    if (pos[0] > pos[6]) pos[0] = pos[6];
    if (pos[2] < pos[4]) pos[2] = pos[4];
    if (pos[2] > pos[6]) pos[2] = pos[6];
    if (pos[1] < pos[5]) pos[1] = pos[5];
    if (pos[1] > pos[7]) pos[1] = pos[7];
    if (pos[3] < pos[5]) pos[3] = pos[5];
    if (pos[3] > pos[7]) pos[3] = pos[7];
    if ((pos[0] == pos[2]) || (pos[1] == pos[3])) {
      r = FALSE;
    }
    else {
      r = TRUE;
    }
  }
  return(r);
}

/* -------------------------------------------------------------
  redraw_over       -- ŤʤåȺ
-------------------------------------------------------------- */
void  redraw_over(void)
{
  GList *pt, *near;
  RRSObj *o, *check;
  gint  i, j, n;

  n = g_list_length(sp_layer);
  pt = sp_layer;
  for(i=0; i<n; i++) {
    o = (RRSObj *)pt->data;
    pt = pt->next;
    if (o->update == FALSE) continue;
    near = sp_layer;
    for(j=0; j<n; j++) {
      check = (RRSObj *)near->data;
      near = near->next;
      if (i == j) continue;
      if (check->update == TRUE) continue;
      if (check_over(o, check) == TRUE) {
	/* - ŤʤäƤǤĤ񤭴о */
	check->update = TRUE;
	/* ƵŪ˽ŤʤǽΤ */
	redraw_over();
      }
    }
  }
}

/* -------------------------------------------------------------
  update_done       -- åץǡȴλ(oldξ񤭤Ȥ)
-------------------------------------------------------------- */
void  update_done(RRSObj *sprite)
{
  sprite->update = FALSE;
  sprite->z_old = sprite->z;
  g_memmove(&(sprite->obj_old), &(sprite->obj), sizeof(RRSprite));
}
